//chap5.cpp
#include "stdafx.h"
#include"chap5.h"

Square::Square(Square &sq)
{
  x1=sq.GetTLX();
  y1=sq.GetTLY();
  x2=sq.GetBRX();
  y2=sq.GetBRY();
}

Square::Square(RECT &rt)
{
  x1=rt.left;
  y1=rt.top;
  x2=rt.right;
  y2=rt.bottom;
}

Square &Square::operator=( Square &sq )
{
  x1=sq.GetTLX();
  y1=sq.GetTLY();
  x2=sq.GetBRX();
  y2=sq.GetBRY();
  return *this;
}

Square &Square::operator=( RECT &rt )
{
  x1=rt.left;
  y1=rt.top;
  x2=rt.right;
  y2=rt.bottom;
  return *this;
}


void Square::Draw(HDC hdc)
{
  HBRUSH lineBrush;
  HBRUSH fillBrush;
  RECT rt;
  rt.top=y1;
  rt.left=x1;
  rt.right=x2;
  rt.bottom=y2;
  
  fillBrush = ::CreateSolidBrush(fillColor);
  lineBrush = ::CreateSolidBrush(lineColor);
  ::FillRect(hdc, &rt, fillBrush);
  ::FrameRect(hdc, &rt,lineBrush );
  ::DeleteObject(fillBrush);
  ::DeleteObject(lineBrush);
}



//circle class definitions
Circle::Circle(Circle &cir)
{
  x=cir.GetCenterX();
  y=cir.GetCenterY();
  r=cir.GetRadius();
}
Circle::Circle(RECT &rt)
{
  x=rt.left + ((rt.right-rt.left)/2);
  y=rt.top + ((rt.bottom-rt.top)/2);
  r=((rt.bottom-rt.top)/2);
}

void Circle::SetCenter(int xr, int yr)
{
  x = xr;
  y = yr;
}
void Circle::SetRadius(int rr)
{
  r = rr;
}

int Circle::GetCenterX()
{
  return x;
}

int Circle::GetCenterY()
{
  return y;
}

int Circle::GetRadius()
{
  return r;
}

Circle &Circle::operator=( Circle &cir )
{
  x = cir.GetCenterX();
  y = cir.GetCenterY();
  r = cir.GetRadius();
  return *this;
}

Circle &Circle::operator=( RECT &rt )
{
  x=rt.left + ((rt.right-rt.left)/2);
  y=rt.top + ((rt.bottom-rt.top)/2);
  r=((rt.bottom-rt.top)/2);
  return *this;
}

void Circle::Draw(HDC hdc)
{
  HPEN linePen;
  HPEN oldPen;

  linePen = ::CreatePen(PS_SOLID,1,lineColor);
  oldPen = (HPEN) ::SelectObject(hdc, linePen);
  ::Ellipse(hdc, x-r,y-r,x+r,y+r);
  ::SelectObject(hdc, oldPen);
  ::DeleteObject(linePen);
}

