// SUBPROC.cpp : Defines the entry point for the DLL application.
//


#include "stdafx.h"
#include <atlbase.h>
#include <atlconv.h>

FARPROC		m_lpfnOrigProc=NULL;
VOID WINAPI UnSubClassWindow(HWND hwnd);

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}


//---------------------------------------------------------------------------
// Sub class routine for target control window proc.
//---------------------------------------------------------------------------
LRESULT __declspec( dllexport) CALLBACK SubClassWinProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    LONG rc;
	WORD	whi;
	WORD	wlo;
	HWND	hwndMain=NULL;
    UINT	tmsg=msg;
	HWND ctl=NULL;
	static HWND	s_hwndlast;
	char cStr[1024];

    //get the window handle
	whi = (WORD) GetProp(hwnd, "MyCallBackHi");
	wlo = (WORD) GetProp(hwnd, "MyCallBackLo");
	ctl = (HWND) MAKELONG(wlo, whi);

    //if we get a good handle
	if (ctl)
	{
		switch(msg)
		{

			//our test simply tracks the menu
			//text and set's it into the window 
			//whose handle is stored in our custom props
			case WM_MENUSELECT:
			{
				if (MF_POPUP & HIWORD(wp))
					GetMenuString((HMENU)lp,LOWORD(wp),cStr,1024,MF_BYPOSITION);
				else
					GetMenuString((HMENU)lp,LOWORD(wp),cStr,1024,MF_BYCOMMAND);
				SetWindowText( ctl, cStr) ;
				return 0;
			}
			break;
			case WM_DESTROY:
			{

			}
		}
    }    
	//handle getting the message to the original proc
	if (m_lpfnOrigProc)
	{
		rc = CallWindowProc((WNDPROC) m_lpfnOrigProc, hwnd, msg, wp, lp);
	}
	if (ctl)
	{
		switch(msg)
		{
			//safety valve, in case we forget
			//this is done after forwarding the 
			//message to the original proc
			case WM_DESTROY:
			{
				UnSubClassWindow(hwnd);
			}
		}
    }    
    return rc;
}



BOOL WINAPI SubClassWindow(HWND hwnd, HWND ctl)
{

	if (!::IsWindow(hwnd))
        return(FALSE);  // Invalid hwnd parameter

	if (!::IsWindow(ctl))
        return(FALSE);  // Invalid ctl parameter

    if (m_lpfnOrigProc)
        return FALSE;   // Already are subclassing

	

	//set in our window proc
	//this subclasses the window
	m_lpfnOrigProc = (FARPROC)::SetWindowLong(hwnd, GWL_WNDPROC, (DWORD)SubClassWinProc);

	//if this was successful
	if (m_lpfnOrigProc)
	{
		//set up our custom props that hold the
		//window handle to communicate with
		SetProp(hwnd, "MyCallBackHi", (HANDLE) (HIWORD (ctl)));
		SetProp(hwnd, "MyCallBackLo", (HANDLE) (LOWORD (ctl)));
	}
    return TRUE;
}

VOID WINAPI UnSubClassWindow(HWND hwnd)
{
	// Make sure we're actually subclassing before we undo it.
	if (m_lpfnOrigProc)
	{
		//take out our custom properties
    	RemoveProp(hwnd, "MyCallBackHi");
    	RemoveProp(hwnd, "MyCallBackLo");
		//set the window proc back
		::SetWindowLong(hwnd, GWL_WNDPROC, (LONG)m_lpfnOrigProc);
		m_lpfnOrigProc = 0L;
	}
}




