#pragma warning(disable:4001)
#define STRICT
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0400
#endif

#include <atlbase.h>
extern CComModule _Module;
#include <atlcom.h>
#include <atlctl.h>
#include "..\include\trnclr.h"

//#include "..\include\error.h"

EXTERN_C void PASCAL GizmosDraw3dText
(
	HDC		hdc,
	LPSTR	lpmem,
	SHORT	tlength,
	LPRECT	lprect,
	WORD	wFormat,
	SHORT	style,
	LONG	textcolor,
	LONG	lightcolor,
	LONG	shadowcolor
)
{
	DWORD	oldcolor;
	RECT	oldrect;
	SHORT	oldbkmode;


	oldrect = *lprect;
	oldcolor = GetTextColor(hdc);
	switch (style)
	{
		case 1:					//raised with light shading
			SetTextColor(hdc, GizmosGetVBSysColors(lightcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			lprect->top++;
			lprect->bottom++;
			lprect->left++;
			lprect->right++;
			oldbkmode = (short)SetBkMode(hdc, TRANSPARENT);
			SetTextColor(hdc, GizmosGetVBSysColors(textcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			SetBkMode(hdc, oldbkmode);
			lprect->top--;
			lprect->left--;
			break;
		case 2:					//raised with heavy shading
			SetTextColor(hdc, GizmosGetVBSysColors(lightcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			lprect->top += 2;
			lprect->bottom += 2;
			lprect->left += 2;
			lprect->right += 2;
			oldbkmode = (short)SetBkMode(hdc, TRANSPARENT);
			SetTextColor(hdc, GizmosGetVBSysColors(shadowcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			lprect->top--;
			lprect->bottom--;
			lprect->left--;
			lprect->right--;
			SetTextColor(hdc, GizmosGetVBSysColors(textcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			SetBkMode(hdc, oldbkmode);
			lprect->top--;
			lprect->left--;
			lprect->bottom++;
			lprect->right++;
			break;
		case 3:					//lowered with light shading
			lprect->top++;
			lprect->bottom++;
			lprect->left++;
			lprect->right++;
			SetTextColor(hdc, GizmosGetVBSysColors(lightcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			lprect->top--;
			lprect->bottom--;
			lprect->left--;
			lprect->right--;
			oldbkmode = (short)SetBkMode(hdc, TRANSPARENT);
			SetTextColor(hdc, GizmosGetVBSysColors(textcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			SetBkMode(hdc, oldbkmode);
			lprect->bottom++;
			lprect->right++;
			break;
		case 4:					//raised with heavy shading
			SetTextColor(hdc, GizmosGetVBSysColors(shadowcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			lprect->top += 2;
			lprect->bottom += 2;
			lprect->left += 2;
			lprect->right += 2;
			oldbkmode = (short)SetBkMode(hdc, TRANSPARENT);
			SetTextColor(hdc, GizmosGetVBSysColors(lightcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			lprect->top--;
			lprect->bottom--;
			lprect->left--;
			lprect->right--;
			SetTextColor(hdc, GizmosGetVBSysColors(textcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			SetBkMode(hdc, oldbkmode);
			lprect->top--;
			lprect->left--;
			lprect->bottom++;
			lprect->right++;
			break;
		default:				//no 3 d effect
			SetTextColor(hdc, GizmosGetVBSysColors(textcolor));
			DrawText(hdc, lpmem, tlength, lprect, wFormat);
			break;

	}
	SetTextColor(hdc, oldcolor);
	*lprect = oldrect;
}

EXTERN_C void FAR PASCAL GizmosDrawRotated3dText
(
	HDC		hdc,
	LPSTR	lpmem,
	SHORT	tlength,
	LPRECT	lprect,
	WORD	wFormat,
	SHORT	style,
	LONG	textcolor,
	LONG	lightcolor,
	LONG	shadowcolor,
	int		rotationamount
)
{   	
	//This function draws the rotated text into lprect
	//It calls GizmosDraw3dText after changing the viewport so the text will show
	RECT focusrect = *lprect;
	RECT textrect = *lprect;
	HRGN focusrgn;	
	int VerticalOffset = 0, HorizontalOffset = 0;
	tlength=tlength;	
	// Set up the region that corresponds to the focus rectangle
	focusrgn = CreateRectRgnIndirect(&focusrect);
	if (focusrgn)
		SelectObject(hdc, focusrgn);
	
	//DrawText(hdc, lpmem, -1, &textrect, wFormat | DT_CALCRECT);
	DrawText(hdc, lpmem, -1, &textrect, DT_SINGLELINE | DT_CALCRECT);
	
	//Get the amount in range
	rotationamount %= 3600;
	//Make it fit one case or another
	rotationamount = ((int)(rotationamount / 900)) * 900;
	
	// Move the viewport origin to align with the focus rectangle
	switch(rotationamount)
	{
		case 2700:
			if (wFormat & DT_BOTTOM)
				{//Bottom
				VerticalOffset = (focusrect.bottom-focusrect.top)-(textrect.right-textrect.left);
				}
			else if (!(wFormat & DT_VCENTER))
				{//Top
				VerticalOffset = focusrect.bottom-focusrect.bottom;
				}
			else
				{//Center
				VerticalOffset = ((focusrect.bottom-focusrect.top)-(textrect.right-textrect.left))/2;
				}
			
			if (wFormat & DT_RIGHT)
				{//Right
				HorizontalOffset = focusrect.right-focusrect.left;
				}
			else if (!(wFormat & DT_CENTER))
				{//Left
				HorizontalOffset = (textrect.bottom-textrect.top);
				}
			else
				{//Center
				HorizontalOffset = ((focusrect.right-focusrect.left)+(textrect.bottom-textrect.top))/2;
				}
			break;
		case 1800:
			if (wFormat & DT_BOTTOM)
				{//Bottom
				VerticalOffset = focusrect.bottom-textrect.top;
				}
			else if (!(wFormat & DT_VCENTER))
				{//Top
				VerticalOffset = textrect.bottom-textrect.top;
				}
			else
				{//Center
				VerticalOffset = ((textrect.bottom-textrect.top)+(focusrect.bottom-focusrect.top))/2;
				}
			
			if (wFormat & DT_RIGHT)
				{//Right
				HorizontalOffset = focusrect.right-focusrect.left;
				}
			else if (!(wFormat & DT_CENTER))
				{//Left
				HorizontalOffset = textrect.right-textrect.left;
				}
			else
				{//Center
				HorizontalOffset = ((focusrect.right-focusrect.left)+(textrect.right-textrect.left))/2;
				}
			break;
		case 900:
			if (wFormat & DT_BOTTOM)
				{//Bottom
				VerticalOffset = focusrect.bottom-focusrect.top;
				}
			else if (!(wFormat & DT_VCENTER))
				{//Top
				VerticalOffset = (textrect.right-textrect.left);
				}
			else
				{//Center
				VerticalOffset = ((focusrect.bottom-focusrect.top)+(textrect.right-textrect.left))/2;
				}
			
			if (wFormat & DT_RIGHT)
				{//Right
				HorizontalOffset = (focusrect.right-focusrect.left)-(textrect.bottom-textrect.top);
				}
			else if (!(wFormat & DT_CENTER))
				{//Left
				HorizontalOffset = 0;
				}
			else
				{//Center
				HorizontalOffset = ((focusrect.right-focusrect.left)-(textrect.bottom-textrect.top))/2;
				}
			break;
		default:
			textrect = *lprect;
			VerticalOffset = 0;
			HorizontalOffset = 0;
			break;
	}

	SetViewportOrgEx(hdc, HorizontalOffset, VerticalOffset, NULL);

	// Draw the text
    GizmosDraw3dText(hdc,
                lpmem,
                -1,
				&textrect,
                wFormat | DT_NOCLIP,
				style,
				textcolor,
				lightcolor,
				shadowcolor
				);

	SetViewportOrgEx(hdc,0,0,NULL);

	// Remove the clipping region
	SelectClipRgn(hdc,NULL);
	
	if (focusrgn) DeleteObject(focusrgn);
}
