#pragma warning(disable:4001)
#define STRICT
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0400
#endif

#include <atlbase.h>
extern CComModule _Module;
#include <atlcom.h>
#include <atlctl.h>


//---------------------------------------------------------------------------
// Pixel <--> Twips Conversion Routines
//---------------------------------------------------------------------------
//we are setting these up for inclusion in the card control, but
//will probably move them to a link library later...
#define TWIPS_PER_INCH 1440
int RoundDiv(long x, short y);
#define RoundDiv(x,y) (int)((x+y/2)/y)

//int _declspec(dllexport) XPixelsToTwips(int xPixels, CDC *pdc)
int XPixelsToTwips(int xPixels, HDC pdc)
{
	int	iTwipsPerPixel;
	int	iLogPixels;
	HDC	dc;

	if (pdc == NULL) 
	{
		dc = CreateIC(_T("Display"), NULL, NULL, NULL);
		iLogPixels = GetDeviceCaps(dc, LOGPIXELSX);
		DeleteDC(dc);
	}
	else 
	{
		iLogPixels = GetDeviceCaps(pdc, LOGPIXELSX);
	}
	if (0==iLogPixels)
		iLogPixels=1;
	iTwipsPerPixel = TWIPS_PER_INCH / iLogPixels;
	return(xPixels * iTwipsPerPixel);
}

//int _declspec(dllexport) YPixelsToTwips(int yPixels, HDC pdc)
int YPixelsToTwips(int yPixels, HDC pdc)
{
	int	iTwipsPerPixel;
	int	iLogPixels;
	HDC	dc;

	if (yPixels < 0)
		yPixels=yPixels;
	if (pdc == NULL) 
	{
		dc = CreateIC(_T("Display"), NULL, NULL, NULL);
		iLogPixels = GetDeviceCaps(dc, LOGPIXELSY);
		DeleteDC(dc);
	}
	else 
	{
		iLogPixels = GetDeviceCaps(pdc, LOGPIXELSY);
	}

	if (0==iLogPixels)
		iLogPixels=1;
	iTwipsPerPixel = TWIPS_PER_INCH / iLogPixels;
	return(yPixels * iTwipsPerPixel);
}

//int _declspec(dllexport) XTwipsToPixels(int xTwips, CDC *pdc)
int XTwipsToPixels(int xTwips, HDC pdc)
{
	int	iTwipsPerPixel;
	int	iLogPixels;
	HDC	dc;

	if (pdc == NULL) 
	{
		dc = CreateIC(_T("Display"), NULL, NULL, NULL);
		iLogPixels = GetDeviceCaps(dc, LOGPIXELSX);
		DeleteDC(dc);
	}
	else 
	{
		iLogPixels = GetDeviceCaps(pdc, LOGPIXELSX);
	}

	if (0==iLogPixels)
		iLogPixels=1;
	iTwipsPerPixel = TWIPS_PER_INCH / iLogPixels;
	return(RoundDiv(xTwips, iTwipsPerPixel));
}

//int _declspec(dllexport) YTwipsToPixels(int xTwips, CDC *pdc)
int YTwipsToPixels(int xTwips, HDC pdc)
{
	int	iTwipsPerPixel;
	int	iLogPixels;
	HDC	dc;

	if (pdc == NULL) 
	{
		dc = CreateIC(_T("Display"), NULL, NULL, NULL);
		iLogPixels = GetDeviceCaps(dc, LOGPIXELSY);
		DeleteDC(dc);
	}
	else 
	{
		iLogPixels = GetDeviceCaps(pdc, LOGPIXELSY);
	}

	if (0==iLogPixels)
		iLogPixels=1;
	iTwipsPerPixel = TWIPS_PER_INCH / iLogPixels;
	return(RoundDiv(xTwips, iTwipsPerPixel));
}

short GetShiftState()
{
	BOOL bShift = (GetKeyState(VK_SHIFT) < 0);
	BOOL bCtrl  = (GetKeyState(VK_CONTROL) < 0);
	BOOL bAlt   = (GetKeyState(VK_MENU) < 0);

	return (short)(bShift + (bCtrl << 1) + (bAlt << 2));
}

void BCPixeltoContainerSize(LPOLECONTROLSITE pcs, LPSIZEL inpix, LPPOINTF incont, LPTSTR scalemode)
{
	SIZEL	tsize;
	POINTL	psize;

	
	AtlPixelToHiMetric( inpix, &tsize );
	psize.x = tsize.cx;
	psize.y = tsize.cy;

	pcs->TransformCoords(&psize, incont,XFORMCOORDS_SIZE | XFORMCOORDS_HIMETRICTOCONTAINER);
	if ((0==lstrcmp("Twip", scalemode)) || (0==lstrcmp("Pixel", scalemode)))
	{
		//round to even number
		incont->x = (float) (long) (incont->x + (float).5);
		incont->y = (float) (long) (incont->y + (float).5);
	}
}

void BCPixeltoContainerPos(LPOLECONTROLSITE pcs, LPSIZEL inpix, LPPOINTF incont, LPTSTR scalemode)
{
	SIZEL	tsize;
	POINTL	psize;

	
	AtlPixelToHiMetric( inpix, &tsize );
	psize.x = tsize.cx;
	psize.y = tsize.cy;

	pcs->TransformCoords(&psize, incont,XFORMCOORDS_POSITION | XFORMCOORDS_HIMETRICTOCONTAINER);

	if ((0==lstrcmp("Twip", scalemode)) || (0==lstrcmp("Pixel", scalemode)))
	{
		//round to even number
		incont->x = (float) (long) (incont->x + (float).5);
		incont->y = (float) (long) (incont->y + (float).5);
	}
}

void BCContainertoPixelSize(LPOLECONTROLSITE pcs, LPSIZEL inpix, LPPOINTF incont)
{
	SIZEL	tsize;
	POINTL	psize;

	
	pcs->TransformCoords(&psize, incont,XFORMCOORDS_SIZE|XFORMCOORDS_CONTAINERTOHIMETRIC);

	tsize.cx = (long)((float) psize.x + (float) .5);
	tsize.cy = (long)((float) psize.y + (float) .5);

	AtlHiMetricToPixel( &tsize, inpix );


}

void BCContainertoPixelPos(LPOLECONTROLSITE pcs, LPSIZEL inpix, LPPOINTF incont)
{
	SIZEL	tsize;
	POINTL	psize;

	
	pcs->TransformCoords(&psize, incont,XFORMCOORDS_POSITION|XFORMCOORDS_CONTAINERTOHIMETRIC);

	tsize.cx = (long)((float) psize.x + (float) .5);
	tsize.cy = (long)((float) psize.y + (float) .5);

	AtlHiMetricToPixel( &tsize, inpix );

}