#pragma warning(disable:4001)
#define STRICT
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0400
#endif

#include <atlbase.h>
extern CComModule _Module;
#include <atlcom.h>
#include <atlctl.h>

#include "gbord.h"
#include "trnclr.h"

BOOL		bTransparent = FALSE;
COLORREF	rgbTransparent = 0;
COLORREF	rgbFore;
COLORREF	rgbBack;

EXTERN_C void FAR PASCAL BCDrawBorder
(
	HWND 	hwnd,    	//the hwnd to draw in
	HDC		hdc,		//the hdc to draw on
	SHORT 	width,		//the width to draw
	SHORT	borderstyle,	//do we draw a border around the border?
	BOOL	fillin,		//fill in the center?
	LONG	fill,		//fill color
	LONG	border,		//border color
	WORD	itemaction,
	LPRECT  lprect
)
{
    RECT    rect={0,0,0,0};
	HPEN	hpenlight=NULL;
	HPEN	hpenshadow=NULL;
	HPEN	hpenface=NULL;
    HPEN    hpenold=NULL;
    HPEN	hpenborder=NULL;
    HPEN	hpenfill=NULL;
    HBRUSH  hbrushfill=NULL;
    int		olddrawmode=0;
    HPEN	lefttoppen=NULL;
    HPEN	rightbottompen=NULL;
   	SHORT	counter=0;
   	HPEN	hpenparent=NULL;
    HBRUSH  hbrushparent=NULL;
   	HDC		temphdc=NULL;
	SHORT	offsetfill=0;
	HWND	hwndParent=NULL;
	BOOL	bdeleteparentbrush=FALSE;

	if (IsWindow(hwnd))
	{
		hwndParent = GetParent(hwnd);
		if (!IsWindow(hwndParent))
			hwndParent = hwnd;
		temphdc = GetDC(hwndParent);
	    hpenparent = CreatePen(PS_SOLID, 1, GetBkColor(temphdc));
	    ReleaseDC(hwndParent, temphdc);
	}
	else
	{
		bdeleteparentbrush = TRUE;
		hbrushparent = CreateSolidBrush(GizmosGetVBSysColors(fill));
	    hpenparent = CreatePen(PS_SOLID, 1, GizmosGetVBSysColors(fill));
	}
    hpenborder = CreatePen(PS_SOLID,1,GizmosGetVBSysColors(border));
    hpenfill = CreatePen(PS_SOLID,1,GizmosGetVBSysColors(fill));
    hbrushfill = CreateSolidBrush(GizmosGetVBSysColors(fill));
	rgbFore=GizmosGetVBSysColors(fill);
	rgbBack=GizmosGetVBSysColors(border);

	hpenlight=CreatePen(PS_SOLID,1,GetSysColor(COLOR_3DHILIGHT));
	hpenshadow=CreatePen(PS_SOLID,1,GetSysColor(COLOR_3DSHADOW));
	hpenface=CreatePen(PS_SOLID,1,GetSysColor(COLOR_3DFACE));
	
	rect = *lprect;
    olddrawmode = SetROP2(hdc, R2_COPYPEN);
    hpenold = (HPEN) SelectObject(hdc,GetStockObject(WHITE_PEN));
    //fill the control if needed
    if (fillin && itemaction == ODA_DRAWENTIRE)
    {
	    FillRect(hdc, &rect, hbrushfill);
	    FrameRect(hdc, &rect, hbrushfill);
    }
	rect = *lprect;
	switch (borderstyle)
	{
	case 0:		//no border
		for (counter = 0;counter < width; counter++)
		{
		    lefttoppen = hpenfill;
		    rightbottompen = hpenfill;
			if (itemaction == ODA_DRAWENTIRE)
		    {
				SelectObject(hdc,lefttoppen);
				MoveToEx(hdc,rect.left,rect.top,NULL);
				LineTo(hdc,rect.right,rect.top);
				MoveToEx(hdc,rect.left,rect.top,NULL);
				LineTo(hdc,rect.left,rect.bottom);

				SelectObject(hdc,rightbottompen);
				MoveToEx(hdc,rect.right-1,rect.top,NULL);
				LineTo(hdc,rect.right-1,rect.bottom);
				MoveToEx(hdc,rect.left,rect.bottom-1,NULL);
				LineTo(hdc,rect.right,rect.bottom-1);
			}
			InflateRect(&rect, -1, -1);
		}
		break;
	case 1:		//3-d border
		for (counter = 0;counter < width; counter++)
		{
		    lefttoppen = hpenfill;
		    rightbottompen = hpenfill;
		    if (0 == counter)
			{
		    	lefttoppen = hpenshadow;
		    	rightbottompen = hpenlight;
			}
		    if (1 == counter)
			{
		    	lefttoppen = hpenborder;
		    	rightbottompen = hpenface;
			}
			if (itemaction == ODA_DRAWENTIRE)
		    {
				SelectObject(hdc,lefttoppen);
				MoveToEx(hdc,rect.left,rect.top,NULL);
				LineTo(hdc,rect.right,rect.top);
				MoveToEx(hdc,rect.left,rect.top,NULL);
				LineTo(hdc,rect.left,rect.bottom);

				SelectObject(hdc,rightbottompen);
				MoveToEx(hdc,rect.right-1,rect.top,NULL);
				LineTo(hdc,rect.right-1,rect.bottom);
				MoveToEx(hdc,rect.left,rect.bottom-1,NULL);
				LineTo(hdc,rect.right,rect.bottom-1);
			}
			InflateRect(&rect, -1, -1);
		}
		break;
	case 2:		//Single Color Border
		for (counter = 0;counter < width; counter++)
		{
		    lefttoppen = hpenfill;
		    rightbottompen = hpenfill;
		    if (0 == counter)
			{
		    	lefttoppen = hpenborder;
		    	rightbottompen = hpenborder;
			}
			if (itemaction == ODA_DRAWENTIRE)
		    {
				SelectObject(hdc,lefttoppen);
				MoveToEx(hdc,rect.left,rect.top,NULL);
				LineTo(hdc,rect.right,rect.top);
				MoveToEx(hdc,rect.left,rect.top,NULL);
				LineTo(hdc,rect.left,rect.bottom);

				SelectObject(hdc,rightbottompen);
				MoveToEx(hdc,rect.right-1,rect.top,NULL);
				LineTo(hdc,rect.right-1,rect.bottom);
				MoveToEx(hdc,rect.left,rect.bottom-1,NULL);
				LineTo(hdc,rect.right,rect.bottom-1);
			}
			InflateRect(&rect, -1, -1);
		}
		break;
    }
    SetROP2(hdc, olddrawmode);
    SelectObject(hdc,hpenold);
	if (bdeleteparentbrush)
		DeleteObject(hbrushparent);
	DeleteObject(hpenparent);
	DeleteObject(hpenborder);
    DeleteObject(hpenshadow);
    DeleteObject(hpenlight);
    DeleteObject(hbrushfill);
    DeleteObject(hpenfill);
	DeleteObject(hpenface);
	*lprect = rect;
}

