// bclabelctl.h : Declaration of the Cbclabel

#ifndef __BCLABEL_H_
#define __BCLABEL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "flashprop.h"

#define BC_LICSTRING "BCLabel Control, CopyRight  2000 BeCubed"

class BCLicense
{
public:
	static BOOL VerifyLicenseKey(BSTR bstr)   
	{
		USES_CONVERSION;
		char		buff[2048];

		lstrcpy(buff, OLE2T(bstr));

		//this is used at runtime to verify the 
		//container can use the file
		return !lstrcmp(buff, BC_LICSTRING);
	}

	static BOOL IsMyLicenseValid() 
	{  
		return TRUE;
	}

	static BOOL IsLicenseValid() 
	{  
		if (IsMyLicenseValid())
			return TRUE;
		else
			return FALSE;
		return TRUE;
	}

	static BOOL GetLicenseKey(DWORD dwReserved, BSTR* pBstr)
	{
		USES_CONVERSION;
		char		buff[2048];
		LPTSTR		pbuff=&buff[0];
		//the key
		if (IsMyLicenseValid())
		{
			//use the global string
			lstrcpy(buff, BC_LICSTRING);
			*pBstr = SysAllocString(T2OLE(pbuff)); 
			return TRUE;   
		}
		else
		{
			return FALSE;
		}
	}   
};

#include "bclabelCP.h"

/////////////////////////////////////////////////////////////////////////////
// Cbclabel
class ATL_NO_VTABLE Cbclabel : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<Ibclabel, &IID_Ibclabel, &LIBID_BCLABELLib>,
	public CComControl<Cbclabel>,
	public IPersistStreamInitImpl<Cbclabel>,
	public IOleControlImpl<Cbclabel>,
	public IOleObjectImpl<Cbclabel>,
	public IOleInPlaceActiveObjectImpl<Cbclabel>,
	public IViewObjectExImpl<Cbclabel>,
	public IOleInPlaceObjectWindowlessImpl<Cbclabel>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<Cbclabel>,
	public IPersistStorageImpl<Cbclabel>,
	public ISpecifyPropertyPagesImpl<Cbclabel>,
	public IQuickActivateImpl<Cbclabel>,
	public IDataObjectImpl<Cbclabel>,
	public IProvideClassInfo2Impl<&CLSID_bclabel, &DIID__IbclabelEvents, &LIBID_BCLABELLib>,
	public IPropertyNotifySinkCP<Cbclabel>,
	public CComCoClass<Cbclabel, &CLSID_bclabel>,
	public IPersistPropertyBagImpl<Cbclabel>,
	public IPerPropertyBrowsingImpl<Cbclabel>,
    public ICategorizeProperties,
	public IObjectSafetyImpl<Cbclabel, 3>,
	public CProxy_IbclabelEvents<Cbclabel>
	//public EventsNameSpace::CProxy_IbclabelEvents<Cbclabel>
	//public IDispEventImpl<1001, Cbclabel>
{
public:
	Cbclabel();
	~Cbclabel();

DECLARE_CLASSFACTORY2(BCLicense)

DECLARE_REGISTRY_RESOURCEID(IDR_BCLABEL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Cbclabel)
	COM_INTERFACE_ENTRY(Ibclabel)
//DEL 	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IPersistPropertyBag)
	COM_INTERFACE_ENTRY(IPerPropertyBrowsing)
	COM_INTERFACE_ENTRY(ICategorizeProperties)
	COM_INTERFACE_ENTRY(IObjectSafety)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
	COM_INTERFACE_ENTRY2(IDispatch, Ibclabel)
END_COM_MAP()

BEGIN_CATEGORY_MAP(Cbclabel) 
	IMPLEMENTED_CATEGORY(CATID_SafeForScripting) 
	IMPLEMENTED_CATEGORY(CATID_SafeForInitializing) 
END_CATEGORY_MAP()

BEGIN_PROP_MAP(Cbclabel)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
	PROP_ENTRY("Alignment",DISPID_BC_ALIGNMENT , CLSID_NULL)
	PROP_ENTRY("VAlignment",DISPID_BC_VALIGNMENT , CLSID_NULL)
	PROP_ENTRY("BackColor",DISPID_BC_BACKCOLOR , CLSID_StockColorPage)
	PROP_ENTRY("BackStyle",DISPID_BC_BACKSTYLE , CLSID_NULL)
	PROP_ENTRY("BorderColor",DISPID_BC_BORDERCOLOR , CLSID_StockColorPage)
	PROP_ENTRY("BorderStyle",DISPID_BC_BORDERSTYLE , CLSID_NULL)
	PROP_ENTRY("BorderSizePix",DISPID_BC_BORDERSIZEPIX , CLSID_NULL)
	PROP_ENTRY("Caption",DISPID_BC_CAPTION , CLSID_NULL)
	PROP_ENTRY("Enabled",DISPID_BC_ENABLED , CLSID_NULL)
	PROP_ENTRY("FlashColor",DISPID_BC_FLASHCOLOR , CLSID_StockColorPage)
	PROP_ENTRY("FlashType",DISPID_BC_FLASHTYPE , CLSID_NULL)
	PROP_ENTRY("Font",DISPID_BC_FONT , CLSID_NULL)
	PROP_ENTRY("ForeColor",DISPID_BC_FORECOLOR , CLSID_StockColorPage)
	PROP_ENTRY("HelpContextID",DISPID_BC_HELPCONTEXTID , CLSID_NULL)
	PROP_ENTRY("MouseIcon",DISPID_BC_MOUSEICON , CLSID_StockPicturePage)
	PROP_ENTRY("MousePointer",DISPID_BC_MOUSEPOINTER , CLSID_NULL)
	PROP_ENTRY("WordWrap",DISPID_BC_WORDWRAP , CLSID_NULL)
	PROP_ENTRY("FlashTime",DISPID_BC_FLASHTIME , CLSID_VCDCFlashProp)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(Cbclabel)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__IbclabelEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(Cbclabel)
	CHAIN_MSG_MAP(CComControl<Cbclabel>)
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnMMessage)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnMMessage)
	MESSAGE_HANDLER(WM_LBUTTONUP, OnMMessage)
	MESSAGE_HANDLER(WM_MOUSEMOVE, OnMMessage)
	MESSAGE_HANDLER(WM_RBUTTONDBLCLK, OnMMessage)
	MESSAGE_HANDLER(WM_RBUTTONDOWN, OnMMessage)
	MESSAGE_HANDLER(WM_RBUTTONUP, OnMMessage)
	MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
	MESSAGE_HANDLER(WM_TIMER, OnTimer)
	MESSAGE_HANDLER(WM_NCHITTEST, OnMMessage)
	MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBK)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_KEYDOWN, OnKey)
END_MSG_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_Ibclabel,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// Ibclabel
public:

	STDMETHOD(DoVerb)(LONG iVerb,LPMSG lpmsg, IOleClientSite *pActiveSite,
				   LONG lindex, HWND hwndParent, LPCRECT lprcPosRect)
	{
		if (iVerb == 1)
			return IOleObjectImpl<Cbclabel>::DoVerb(OLEIVERB_PROPERTIES, lpmsg, pActiveSite,
												lindex, hwndParent, lprcPosRect);

		return IOleObjectImpl<Cbclabel>::DoVerb(iVerb, lpmsg, pActiveSite,
												lindex, hwndParent, lprcPosRect);

	}

    STDMETHOD(GetControlInfo)(LPCONTROLINFO  lpi )
	{
		USES_CONVERSION;
		HACCEL hAccel = NULL;
		TCHAR cMnemonic = '\0';
		
		// nw - we need a COPY of the caption string
		//      otherwise, we convert the real caption to UPPERCASE!
		CComBSTR	strCaptionCopy = m_caption.Copy();
		LPTSTR lpszStart = OLE2T(strCaptionCopy.m_str);
		LPTSTR lpszNext = lpszStart;
		
		lpszNext = CharUpper(lpszNext);		//Mnemonic characters must be 
													//upper-case in the 
		//Go through the string looking at all ambersand characters.  The last
		//valid ambersand/character combination is what we are looking for.
		//Note: We could start at the end of the string and use 
		//CharPrev/AnsiPrev, but this would be grossly inefficient.  
		//CharPrev/AnsiPrev always start at the beginning of the string and 
		//move upward to n characters prior to the end of the string.  This 
		//happens on each call.  Its easier just to start at the beginning 
		//and move through the entire string touching each character just 
		//once.
		while (lpszNext != NULL && *lpszNext != '\0')
		{
			//Loop till we find the next ambersand or the end of the string
			while (lpszNext != NULL && *lpszNext != '\0' && *lpszNext != '&')
				lpszNext = CharNext(lpszNext);
		
			//See if we have an ambersand followed by a valid character
			if (lpszNext != NULL && *lpszNext == '&')
			{
				//Move to the character following the ambersand
				lpszNext = CharNext(lpszNext);		
				//Make sure the second character is not NULL and not a second 
				//ambersand
				if (lpszNext != NULL && *lpszNext != '\0' && *lpszNext != '&')
					cMnemonic = *lpszNext;											
			}
			
			//Keep moving through the string if we haven't reached the end
			if (lpszNext != NULL && *lpszNext != '\0')	
				lpszNext = CharNext(lpszNext);
		}
		
		if (cMnemonic != NULL)
		{
    
			ACCEL Accel[2];
    
			Accel[0].fVirt = FVIRTKEY | FALT;
			Accel[0].key = cMnemonic;
			Accel[0].cmd = 1;

			Accel[1].fVirt = FVIRTKEY | FALT | FSHIFT;
			Accel[1].key = cMnemonic;
			Accel[1].cmd = 1;
				
			hAccel = CreateAcceleratorTable(Accel, 2);

		}
			
		if (hAccel != NULL)
		{
			lpi->cb = sizeof(CONTROLINFO);
			lpi->hAccel = hAccel;			//Accelerator table created above
			lpi->cAccel = 2;				//Number of accelerators in the table
			lpi->dwFlags = NULL; 			//Can use CTRLINFO_EATS_RETURN or 
												//CTRLINFO_EATS_ESCAPE here
			
		}
		return S_OK;
	}

	
	//takes care of focus
	HRESULT InPlaceActivate(LONG iVerb, const RECT* /*prcPosRect*/)
	{
		HRESULT hr;

		if (m_spClientSite == NULL)
			return S_OK;

		CComPtr<IOleInPlaceObject> pIPO;
		ControlQueryInterface(IID_IOleInPlaceObject, (void**)&pIPO);
		ATLASSERT(pIPO != NULL);

		if (!m_bNegotiatedWnd)
		{
			if (!m_bWindowOnly)
				// Try for windowless site
				hr = m_spClientSite->QueryInterface(IID_IOleInPlaceSiteWindowless, (void **)&m_spInPlaceSite);

			if (m_spInPlaceSite)
			{
				m_bInPlaceSiteEx = TRUE;
				// CanWindowlessActivate returns S_OK or S_FALSE
				if ( m_spInPlaceSite->CanWindowlessActivate() == S_OK )
				{
					m_bWndLess = TRUE;
					m_bWasOnceWindowless = TRUE;
				}
				else
				{
					m_bWndLess = FALSE;
				}
			}
			else
			{
				m_spClientSite->QueryInterface(IID_IOleInPlaceSiteEx, (void **)&m_spInPlaceSite);
				if (m_spInPlaceSite)
					m_bInPlaceSiteEx = TRUE;
				else
					hr = m_spClientSite->QueryInterface(IID_IOleInPlaceSite, (void **)&m_spInPlaceSite);
			}
		}

		ATLASSERT(m_spInPlaceSite);
		if (!m_spInPlaceSite)
			return E_FAIL;

		m_bNegotiatedWnd = TRUE;

		if (!m_bInPlaceActive)
		{

			BOOL bNoRedraw = FALSE;
			if (m_bWndLess)
				m_spInPlaceSite->OnInPlaceActivateEx(&bNoRedraw, ACTIVATE_WINDOWLESS);
			else
			{
				if (m_bInPlaceSiteEx)
					m_spInPlaceSite->OnInPlaceActivateEx(&bNoRedraw, 0);
				else
				{
					hr = m_spInPlaceSite->CanInPlaceActivate();
					// CanInPlaceActivate returns S_FALSE or S_OK
					if (FAILED(hr))
						return hr;
					if ( hr != S_OK )
					{
					   // CanInPlaceActivate returned S_FALSE.
					   return( E_FAIL );
					}
					m_spInPlaceSite->OnInPlaceActivate();
				}
			}
		}

		m_bInPlaceActive = TRUE;

		// get location in the parent window,
		// as well as some information about the parent
		//
		OLEINPLACEFRAMEINFO frameInfo;
		RECT rcPos, rcClip;
		CComPtr<IOleInPlaceFrame> spInPlaceFrame;
		CComPtr<IOleInPlaceUIWindow> spInPlaceUIWindow;
		frameInfo.cb = sizeof(OLEINPLACEFRAMEINFO);
		HWND hwndParent;
		if (m_spInPlaceSite->GetWindow(&hwndParent) == S_OK)
		{
			m_spInPlaceSite->GetWindowContext(&spInPlaceFrame,
				&spInPlaceUIWindow, &rcPos, &rcClip, &frameInfo);

			if (!m_bWndLess)
			{
				if (m_hWndCD)
				{
					::ShowWindow(m_hWndCD, SW_SHOW);
					if (m_bTabStop)
					{
						if (!::IsChild(m_hWndCD, ::GetFocus()))
							::SetFocus(m_hWndCD);
					}
				}
				else
				{
					HWND h = CreateControlWindow(hwndParent, rcPos);
					ATLASSERT(h != NULL);	// will assert if creation failed
					ATLASSERT(h == m_hWndCD);
					h;	// avoid unused warning
				}
			}

			pIPO->SetObjectRects(&rcPos, &rcClip);
		}

		CComPtr<IOleInPlaceActiveObject> spActiveObject;
		ControlQueryInterface(IID_IOleInPlaceActiveObject, (void**)&spActiveObject);

		// Gone active by now, take care of UIACTIVATE
		if (DoesVerbUIActivate(iVerb))
		{
			if (!m_bUIActive)
			{
				m_bUIActive = TRUE;
				hr = m_spInPlaceSite->OnUIActivate();
				if (FAILED(hr))
					return hr;

				if (m_bTabStop)
					SetControlFocus(TRUE);
				// set ourselves up in the host.
				//
				if (spActiveObject)
				{
					if (spInPlaceFrame)
						spInPlaceFrame->SetActiveObject(spActiveObject, NULL);
					if (spInPlaceUIWindow)
						spInPlaceUIWindow->SetActiveObject(spActiveObject, NULL);
				}

				if (spInPlaceFrame)
					spInPlaceFrame->SetBorderSpace(NULL);
				if (spInPlaceUIWindow)
					spInPlaceUIWindow->SetBorderSpace(NULL);
			}
		}

		m_spClientSite->ShowObject();

		return S_OK;
	}

// IPerPropertyBrowsing
    STDMETHODIMP MapPropertyToPage(/*[in]*/ DISPID dispID, /*[out*/ CLSID *pClsid);
	STDMETHODIMP GetDisplayString(DISPID dispID,BSTR *pBstr);
	STDMETHODIMP GetPredefinedStrings(DISPID dispID, CALPOLESTR *pCaStringsOut,CADWORD *pCaCookiesOut);
	STDMETHODIMP GetPredefinedValue(DISPID dispID, DWORD dwCookie, VARIANT* pVarOut);

// ICategorizeProperties
    STDMETHODIMP MapPropertyToCategory(/*[in]*/ DISPID dispid, /*[out]*/ PROPCAT* ppropcat);
    STDMETHODIMP GetCategoryName(/*[in]*/ PROPCAT propcat, /*[in]*/ LCID lcid, /*[out]*/ BSTR* pbstrName);

	void SomethingChanged(DISPID id);
	HRESULT BCFireOnRequestEdit(DISPID id);
	
	STDMETHODIMP GetEnumList(CALPOLESTR *pCaStringsOut,CADWORD *pCaCookiesOut, LPTSTR lpElements, short cOffset);
	STDMETHODIMP GetEnumString(	BSTR	*pBstr,
										LPTSTR	lpElements,
										short	svalue,
										short	sOffset);
	HRESULT OnDraw(ATL_DRAWINFO& di);
	STDMETHOD (SetClientSite)(LPOLECLIENTSITE pSite);
	LRESULT OnMMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSetCursor(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnTimer(UINT uMsg, WPARAM wp, LPARAM lp, BOOL& bHandled);
	LRESULT OnEraseBK(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnKey(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);



		STDMETHOD (About)();
        STDMETHOD (Refresh)();
        STDMETHOD (Zorder)(VARIANT);
        STDMETHOD (get_Alignment)(/*[out, retval]*/ enumAlignment* );
        STDMETHOD (put_Alignment)(/*[in]*/ enumAlignment );
        STDMETHOD (get_VAlignment)(/*[out, retval]*/ enumVAlignment* );
        STDMETHOD (put_VAlignment)(/*[in]*/ enumVAlignment );
        STDMETHOD (get_BackColor)(/*[out, retval]*/ OLE_COLOR* );
        STDMETHOD (put_BackColor)(/*[in]*/ OLE_COLOR );
        STDMETHOD (get_BackStyle)(/*[out, retval]*/ enumBackStyle* );
        STDMETHOD (put_BackStyle)(/*[in]*/ enumBackStyle );
        STDMETHOD (get_BorderColor)(/*[out, retval]*/ OLE_COLOR* );
        STDMETHOD (put_BorderColor)(/*[in]*/ OLE_COLOR );
        STDMETHOD (get_BorderStyle)(/*[out, retval]*/ enumBorderStyle* );
        STDMETHOD (put_BorderStyle)(/*[in]*/ enumBorderStyle );
        STDMETHOD (get_BorderSize)(/*[out, retval]*/ float* );
        STDMETHOD (put_BorderSize)(/*[in]*/ float );
        STDMETHOD (get_Caption)(/*[out, retval]*/ BSTR* );
        STDMETHOD (put_Caption)(/*[in]*/ BSTR );
        STDMETHOD (get_Enabled)(/*[out, retval]*/ VARIANT_BOOL* );
        STDMETHOD (put_Enabled)(/*[in]*/ VARIANT_BOOL );
        STDMETHOD (get_FlashColor)(/*[out, retval]*/ OLE_COLOR* );
        STDMETHOD (put_FlashColor)(/*[in]*/ OLE_COLOR );
        STDMETHOD (get_FlashType)(/*[out, retval]*/ enumFlashType* );
        STDMETHOD (put_FlashType)(/*[in]*/ enumFlashType );
        STDMETHOD (get_Font)(/*[out, retval]*/ IFontDisp** );
        STDMETHOD (putref_Font)(/*[in, out]*/ IFontDisp* );
        STDMETHOD (get_ForeColor)(/*[out, retval]*/ OLE_COLOR* );
        STDMETHOD (put_ForeColor)(/*[in]*/ OLE_COLOR );
        STDMETHOD (get_HelpContextID)(/*[out, retval]*/ long* );
        STDMETHOD (put_HelpContextID)(/*[in]*/ long );
        STDMETHOD (get_MouseIcon)(/*[out, retval]*/ IPictureDisp** );
        STDMETHOD (putref_MouseIcon)(/*[in, out]*/ IPictureDisp* );
        STDMETHOD (get_MousePointer)(/*[out, retval]*/ enumMousePointer* );
        STDMETHOD (put_MousePointer)(/*[in]*/ enumMousePointer );
        STDMETHOD (get_WordWrap)(/*[out, retval]*/ VARIANT_BOOL* );
        STDMETHOD (put_WordWrap)(/*[in]*/ VARIANT_BOOL );
        STDMETHOD (get_FlashTime)(/*[out, retval]*/ long* );
        STDMETHOD (put_FlashTime)(/*[in]*/ long );

		STDMETHOD (put_BorderSizePix)(/*[in]*/ long newVal);
		STDMETHOD (get_BorderSizePix)(/*[out, retval]*/ long *pVal);
		

	short			m_alignment;
	short			m_valignment;
	OLE_COLOR		m_backcolor;
	short			m_backstyle;
	OLE_COLOR		m_bordercolor;
	short			m_borderstyle;
	long			m_bordersize;
	CComBSTR		m_caption;
	VARIANT_BOOL	m_enabled;
	OLE_COLOR		m_flashcolor;
	short			m_flashtype;
    CComPtr<IFontDisp>	m_pfont;
	HFONT			m_hfont;
	OLE_COLOR		m_forecolor;
	long			m_helpcontextid;
	CComPtr<IPictureDisp> m_pmouseicon;
	short			m_mousepointer;
	VARIANT_BOOL	m_wordwrap;
	long				m_flashtime;
	LPOLECONTROLSITE		m_polecontrolsite;
	short			m_sButton;
	short			m_overcontrol;
	DWORD			m_lastflash;
	short			m_curflash;
	DWORD			m_cookie;
	//ComPtr<Ibcstate>	m_hovering;
	//CComPtr<Ibcstate>	m_normal;

// _VCDCFlashProp
};

#endif //__BCLABEL_H_
